Subject: Use a hashtable for the global symbols

---

 source/interpret.c |  137 +++++++++++++++++++++++++++++++++++++----------------
 source/interpret.h |    1
 source/interpret.c |  135 +++++++++++++++++++++++++++++++++++++----------------
 source/interpret.h |    3 -
 2 files changed, 98 insertions(+), 40 deletions(-)

diff --quilt old/source/interpret.c new/source/interpret.c
--- old/source/interpret.c
+++ new/source/interpret.c
@@ -95,7 +95,10 @@ static int callSubroutineFromSymbol(Symb
 static int concatenateNwithSep(int nVals, const char *sep, char **result,
         int leaveParams);
 static int makeArrayKeyFromArgs(int nArgs, char **keyString, int leaveParams);
-static void freeSymbolTable(Symbol *symTab);
+static void freeSymbolList(Symbol *symList);
+static void addToGlobalSymTab(Symbol *sym);
+static unsigned int hashNameWith(unsigned int hash, const char *name);
+static unsigned int hashName(const char *name);
 static int errCheck(const char *s);
 static int execError(const char *s1, const char *s2);
 static rbTreeNode *arrayEmptyAllocator(void);
@@ -138,8 +141,11 @@ static void stackdumpInternal(int n, int
 #define DISASM_RT(i, n)
 #endif /* #ifndef DEBUG_STACK */
 
-/* Global symbols and function definitions */
-static Symbol *GlobalSymList = NULL;
+/* Global symbols and function definitions, is null initialized */
+#define GLOBAL_SYMTAB_SHIFT 8
+#define GLOBAL_SYMTAB_SIZE (1u << (GLOBAL_SYMTAB_SHIFT))
+#define GLOBAL_SYMTAB_MASK ((GLOBAL_SYMTAB_SIZE) - 1)
+static Symbol *GlobalSymTab[GLOBAL_SYMTAB_SIZE];
 
 /* List of all memory allocated for strings */
 static char *AllocatedStrings = NULL;
@@ -316,7 +322,7 @@ Program *FinishCreatingProgram(Accumulat
 void FreeProgram(Program *prog)
 {
     if (--prog->refcount == 0) {
-        freeSymbolTable(prog->localSymList);
+        freeSymbolList(prog->localSymList);
         XtFree((char *)prog->code);
         XtFree((char *)prog->name);
         XtFree((char *)prog);
@@ -761,14 +767,14 @@ Symbol *InstallMultiAssignExpr(void)
 ** install an array iteration symbol
 ** it is tagged as an integer but holds an array node pointer
 */
-#define ARRAY_ITER_SYM_PREFIX "aryiter "
+#define ARRAY_ITER_SYM_PREFIX "aryiter #"
 Symbol *InstallIteratorSymbol(void)
 {
     char symbolName[sizeof(ARRAY_ITER_SYM_PREFIX) + TYPE_INT_STR_SIZE(int)];
     DataValue value;
-    static int interatorNameIndex = 0;
+    static int interatorNameIndex;
 
-    sprintf(symbolName, ARRAY_ITER_SYM_PREFIX "#%d", interatorNameIndex);
+    sprintf(symbolName, ARRAY_ITER_SYM_PREFIX "%d", interatorNameIndex);
     ++interatorNameIndex;
     value.tag = INT_TAG;
     value.val.arrayPtr = NULL;
@@ -781,15 +787,19 @@ Symbol *InstallIteratorSymbol(void)
 */
 Symbol *LookupStringConstSymbol(const char *value)
 {
+    unsigned int idx;
     Symbol *s;
 
-    for (s = GlobalSymList; s != NULL; s = s->next) {
-        if (s->type == CONST_SYM &&
-            s->value.tag == STRING_TAG &&
-            !strcmp(s->value.val.str.rep, value)) {
-            return(s);
+    for (idx = 0; idx < GLOBAL_SYMTAB_SIZE; idx++) {
+        for (s = GlobalSymTab[idx]; s != NULL; s = s->next) {
+            if (s->type == CONST_SYM
+                    && s->value.tag == STRING_TAG
+                    && !strcmp(s->value.val.str.rep, value)) {
+                return(s);
+            }
         }
     }
+
     return(NULL);
 }
 
@@ -812,19 +822,39 @@ Symbol *InstallStringConstSymbol(const c
     return(InstallSymbol(stringName, CONST_SYM, value));
 }
 
+static Symbol *lookupSymbol(Symbol *symlist, const char *name,
+        unsigned int hash)
+{
+    while (NULL != symlist) {
+        if (hash == symlist->hash && strcmp(symlist->name, name) == 0)
+            return symlist;
+        symlist = symlist->next;
+    }
+
+    return NULL;
+}
+
 /*
 ** find a symbol in the symbol table
 */
 Symbol *LookupSymbol(const char *name)
 {
+    unsigned int hash;
     Symbol *s;
 
-    for (s = LocalSymList; s != NULL; s = s->next)
-	if (strcmp(s->name, name) == 0)
-	    return s;
-    for (s = GlobalSymList; s != NULL; s = s->next)
-	if (strcmp(s->name, name) == 0)
-	    return s;
+    /* calculate hash for name */
+    hash = hashName(name);
+
+    /* search in local symbols */
+    s = lookupSymbol(LocalSymList, name, hash);
+    if (NULL != s)
+        return s;
+
+    /* search in global symbols */
+    s = lookupSymbol(GlobalSymTab[hash & GLOBAL_SYMTAB_MASK], name, hash);
+    if (NULL != s)
+        return s;
+
     return NULL;
 }
 
@@ -835,17 +865,17 @@ Symbol *InstallSymbol(const char *name, 
 {
     Symbol *s;
 
-    s = (Symbol *)malloc(sizeof(Symbol));
-    s->name = (char *)malloc(strlen(name)+1); /* +1 for '\0' */
+    s = XtNew(Symbol);
+    s->name = (char *)XtMalloc(strlen(name) + 1); /* +1 for '\0' */
     strcpy(s->name, name);
     s->type = type;
     s->value = value;
+    s->hash = hashName(s->name);
     if (type == LOCAL_SYM) {
     	s->next = LocalSymList;
     	LocalSymList = s;
     } else {
-    	s->next = GlobalSymList;
-    	GlobalSymList = s;
+        addToGlobalSymTab(s);
     }
     return s;
 }
@@ -909,8 +939,7 @@ Symbol *PromoteToGlobal(Symbol *sym)
        but this symbol has no program attached and ProgramFree() is not NULL
        pointer safe */
     sym->type = GLOBAL_SYM;
-    sym->next = GlobalSymList;
-    GlobalSymList = sym;
+    addToGlobalSymTab(sym);
 
     return sym;
 }
@@ -1133,6 +1162,7 @@ void GarbageCollectStrings(void)
     SparseArrayEntryWrapper *nextAP, *thisAP;
     char *p, *next;
     Symbol *s;
+    unsigned int idx;
 
     /* mark all strings as unreferenced */
     for (p = AllocatedStrings; p != NULL; p = *((char **)p)) {
@@ -1146,15 +1176,17 @@ void GarbageCollectStrings(void)
 
     /* Sweep the global symbol list, marking which strings are still
        referenced */
-    for (s = GlobalSymList; s != NULL; s = s->next) {
-    	if (s->value.tag == STRING_TAG) {
-            /* test first because it may be read-only static string */
-            if (!(*(s->value.val.str.rep - 1))) {
-    	        *(s->value.val.str.rep - 1) = 1;
+    for (idx = 0; idx < GLOBAL_SYMTAB_SIZE; idx++) {
+        for (s = GlobalSymTab[idx]; s != NULL; s = s->next) {
+            if (s->value.tag == STRING_TAG) {
+                /* test first because it may be read-only static string */
+                if (!(*(s->value.val.str.rep - 1))) {
+                    *(s->value.val.str.rep - 1) = 1;
+                }
+            }
+            else if (s->value.tag == ARRAY_TAG) {
+                MarkArrayContentsAsUsed(s->value.val.arrayPtr);
             }
-        }
-        else if (s->value.tag == ARRAY_TAG) {
-            MarkArrayContentsAsUsed(s->value.val.arrayPtr);
         }
     }
 
@@ -1221,16 +1253,41 @@ static void restoreContext(RestartData *
     FocusWindow = context->focusWindow;
 }
 
-static void freeSymbolTable(Symbol *symTab)
+static void freeSymbolList(Symbol *symList)
 {
     Symbol *s;
     
-    while(symTab != NULL) {
-    	s = symTab;
-    	free(s->name);
-    	symTab = s->next;
-    	free((char *)s);
-    }    
+    while (symList != NULL) {
+        s = symList;
+        symList = s->next;
+        XtFree((char *)s->name);
+        XtFree((char *)s);
+    }
+}
+
+static unsigned int hashNameWith(unsigned int hash, const char *name)
+{
+    while (*name) {
+        unsigned int c = *name++;
+        hash = (hash * 16777619u) + c;
+    }
+
+    return hash;
+}
+
+static unsigned int hashName(const char *name)
+{
+    return hashNameWith(2166136261u, name);
+}
+
+static void addToGlobalSymTab(Symbol *sym)
+{
+    unsigned int idx;
+
+    idx = sym->hash & GLOBAL_SYMTAB_MASK;
+
+    sym->next = GlobalSymTab[idx];
+    GlobalSymTab[idx] = sym;
 }
 
 /* true, if you can pop n values */
diff --quilt old/source/interpret.h new/source/interpret.h
--- old/source/interpret.h
+++ new/source/interpret.h
@@ -101,7 +101,8 @@ typedef struct SymbolRec {
     char *name;
     enum symTypes type;
     DataValue value;
-    struct SymbolRec *next;     /* to link to another */  
+    unsigned int hash;
+    struct SymbolRec *next;     /* to link to another */
 } Symbol;
 
 typedef struct ProgramTag {
